﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CryptoPhoto
{
    class Program
    {
        static string PrivateKey = "00000000000000000000000000000000"; // Get these from https://cryptophoto.com/admin/account
        static string PublicKey = "00000000000000000000000000000000"; // Get these from https://cryptophoto.com/admin/account


        static void Main(string[] args)
        {
            int uID = 123456; // This should be the UserID of your customer. (It does not get revealed)
            string userIP = "127.0.0.1"; // Adjust this to get the customer's IP address from your web server environment (e.g. Request.UserHostAddress)

            // Request a new CryptoPhoto session
            CryptoPhotoUtils cpUtils = new CryptoPhotoUtils(PrivateKey, PublicKey);
            List<string> sessionResponse = cpUtils.StartSession(uID, userIP);

            // Check if session request was successful
            bool isSessionValid = !string.IsNullOrEmpty(cpUtils.SessionID);

            if (!isSessionValid)
            {
                Console.WriteLine("Error: {0}", sessionResponse[1]);
                Console.ReadKey();
                return;
            }

            Console.WriteLine("Session ID: {0}\n", cpUtils.SessionID);

            string generateTokenWidgetHtml = cpUtils.GetGenWidget(); // This is the token generation HTML for your web page to use
            Console.WriteLine("Generate Token Form:\n\n{0}\n\n\n", generateTokenWidgetHtml);

            sessionResponse = cpUtils.StartSession(uID, userIP, true);

            bool isSessionValid = !string.IsNullOrEmpty(cpUtils.SessionID);

            if (!isSessionValid)
            {
                Console.WriteLine("Error: {0}", sessionResponse[1]);
                Console.ReadKey();
                return;
            }

            string authWidgetHtml = cpUtils.GetAuthWidget(); // This is the token challenge HTML for your web page to use
            Console.WriteLine("Auth Token Form:\n\n{0}\n\n\n", authWidgetHtml);

            // verify response
            /* This is just a demo of how the function should be used;  without valid
             * parameters, it is natural that it will return an error message, it is
             * supposed to work when integrated with the login, when you provide
             * a real, valid IP and valid authentication codes
             */
            List<string> verificationResponse = cpUtils.VerifyResponse("selector", "responseRow", "responseColumn", "cph", uID, userIP);

            if (verificationResponse[0] == "success")
            {
                Console.WriteLine("Authenticated");
            }
            else
            {
                Console.WriteLine("Authentication error: {0}", verificationResponse[1]);
            }

            Console.ReadKey();
        }
    }
}
